#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <map>

using namespace std;

static int TextAttr = 7;
static int OldAttr = 0xFF;
static const int AnsiOpt = 1;
static const int Colors  = 1;
static void SetAttr(int newattr)
{
	TextAttr = newattr;
}
static void FlushSetAttr()
{
    if(TextAttr == OldAttr)return;
    if(!Colors)goto Ret;

    #ifdef DJGPP
    textattr(TextAttr);
    #else
    
    cout << "\33[";

    if(TextAttr != 7)
    {
    	static char Swap[] = "04261537";
    	
    	if(AnsiOpt)
    	{
	    	int pp=0;
	    	
	    	if((OldAttr&0x80) > (TextAttr&0x80)
	    	|| (OldAttr&0x08) > (TextAttr&0x08))
	    	{
	    		cout << '0'; pp=1;
	    		OldAttr = 7;
	    	}    	
	    	
	    	if((TextAttr&0x08) && !(OldAttr&0x08)){if(pp)cout<<';';cout<<'1';pp=1;}
	    	if((TextAttr&0x80) && !(OldAttr&0x80)){if(pp)cout<<';';cout<<'5';pp=1;}
	       	
	       	if((TextAttr&0x70) != (OldAttr&0x70))
	       	{
	   	   		if(pp)cout<<';';
	   	   		cout<<'4'<<Swap[(TextAttr>>4)&7];
	       		pp=1;
	       	}
	       	
	      	if((TextAttr&7) != (OldAttr&7))
	      	{
	       		if(pp)cout<<';';
	       		cout<<'3'<<Swap[TextAttr&7];
	       	}
       	}
       	else
       	{
       		cout << '0';
       		if(TextAttr&8)cout << ";1";
       		if(TextAttr&0x80)cout << ";5";
       		cout << '3' << Swap[(TextAttr>>4)&7];
       		cout << ";4" << Swap[TextAttr&7];
       	}
    }
    cout << 'm';
    #endif
Ret:OldAttr = TextAttr;
}

static void FlushSetAttr(int newattr)
{
	SetAttr(newattr);
	FlushSetAttr();
}

class ulkonako
{
    friend class monsters;
    unsigned xsize, ysize;
    string nako, vari;
public:
    void set(unsigned x,unsigned y, const string &n, const string &v)
    {
        xsize=x, ysize=y, nako=n;
        
        unsigned a, b=v.size();
        
        for(a=0; a<b; ++a)
        {
            char c = v[a];
            if(c > '0' && c <= '9')
                vari += char(c - '0');
            else if(c >= 'A' && c <= 'F')
                vari += char(c - 'A' + 10);
            else
                vari += char(0);            
        }
    }
    void show()
    {
    	unsigned x, y;
    	const char *n = nako.c_str();
    	const char *v = vari.c_str();
    	
    	for(y=0; y<ysize; ++y)
    	{
    		for(x=0; x<xsize; ++x)
    		{
    			SetAttr(*v++);
    			FlushSetAttr();
    			cout << *n++;
    		}
    		for(x=0; x<xsize; ++x)cout << '\b';
    		cout << '\n';
    	}
    }
    void hide()
    {
    	unsigned x, y;
    	//const char *n = nako.c_str();
    	//const char *v = vari.c_str();
    	
		SetAttr(0);
		FlushSetAttr();
    	for(y=0; y<ysize; ++y)
    	{
    		for(x=0; x<xsize; ++x)cout << ' ';
    		for(x=0; x<xsize; ++x)cout << '\b';
    		cout << '\n';
    	}
    }
};

class monster
{
	friend class monsters;
    string name, desc;
    vector<ulkonako> nako;
public:
    void load(ifstream &f)
    {
        string s;
        map<string, unsigned> counts;
        map<string, string> contents;
        
        while(f.good())
        {
            getline(f, s);
            if(!s.size())break;
            
            string name = s.substr(0, 4);
            
            ++counts[name];
            contents[name] += s.substr(5);
        }
        name = contents["NAME"];
        desc = contents["DESC"];
        s = contents["SEQV"] + ' ';
        unsigned a, b=s.size(), pos;
        for(a=pos=0; a<b; ++a)
            if(s[a]==' ')
            {
                unsigned y, ycount = counts["ANIM"];
                string t1, s1 = contents["ANIM"];
                string t2, s2 = contents["COLO"];
                
                for(y=0; y<ycount; ++y)
                {
                    t1 += s1.substr(y*(s.size()-1)+pos, a-pos);
                    t2 += s2.substr(y*(s.size()-1)+pos, a-pos);
                }
                
                ulkonako tmp;
                tmp.set(a-pos, ycount, t1, t2);
                nako.push_back(tmp);
                
                pos = a+1;
            }
    }
    void show()
    {
    	FlushSetAttr(1); cout << "Name: ";
    	FlushSetAttr(9); cout << name << endl;
    	FlushSetAttr(1); cout << "Desc: ";
    	FlushSetAttr(9); cout << desc << endl;
    	
    	for(unsigned x=0; x<nako.size(); ++x)
    	{
	    	nako[x].show();
	    	cout << endl;
	    }
    }
};

class monsters
{
	map <string, monster> coll;
	
public:
	monsters()
	{
    	ifstream f("si.dat");
    	
    	while(f.good())
    	{
    		monster tmp;
    		tmp.load(f);
    		tmp.show();
    		
    		coll[tmp.nako[0].nako] = tmp;
    	}
	}
} monsters;

class level
{
	class monsterinstance
	{
		monster &who;
	public:
		monsterinstance(monster &w) : who(w)
		{
		}
	};
public:
    void load(ifstream &f)
    {
    	string s;
    	//unsigned y=0;
    	
        while(f.good())
        {
            getline(f, s);
            if(!s.size())break;
            
            const char *q = s.c_str() + 2;
            
            cout << q << endl;
            
            unsigned x=0;
            while(*q)
            {
            	if(*q == ' ') { ++x; ++q; continue; }
            	string t;
            	while(*q && *q != ' ') t += *q++;
            	cout << "Contains: \33[1;44m" << t << "\33[m\n";
            	x += t.size();
            }
        }   	
    }
    void show()
    {
    }
};

void LoadLevels()
{
	ifstream f("si.lvl");
	
	while(f.good())
	{
		level tmp;
		tmp.load(f);
		tmp.show();
	}
}

int main()
{
	cout << "\33(U";
	
	LoadLevels();

	FlushSetAttr(7);
	
    return 0;
}
